<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>CRUD</title>
</head>
<body>
    <h1>C.R.U.D. DEBUGGER</h1>
    <div class="wrapper">
        <table>
            <tr>
                <td><label for="url">URL:</label></td>
                <td><input id="url" name="url" type="text" aria-label="URL"></td>
            </tr>
            <tr>
                <td><label for="method">METHOD:</label></td>
                <td><input id="method" autocomplete="off" name="method" list="methods"></td>
                <datalist id="methods">
                    <option value="PUT">CREATE</option>
                    <option value="GET">RETRIEVE</option>
                    <option value="POST">UPDATE</option>
                </datalist>
            </tr>
            <tr>
                <td>HEADERS:</td>
                <td></td>
            <tr>
                <td valign="baseline"><label for="data"></label></td>
                <td><div id="headers"></div></td>
            <tr>
                <td>DATA:</td>
                <td></td>
            </tr>

            <tr id="type">
                <td><label for="datatype">TYPE:</label></td>
                <td><input id="datatype" autocomplete="off" name="datatype" list="datatypes"></td>
                <datalist id="datatypes">
                    <option value="xml"></option>
                    <option value="html"></option>
                    <option value="script"></option>
                    <option value="json"></option>
                    <option value="text"></option>
                </datalist>
            </tr>
            <tr>
                <td valign="baseline"><label for="data"></label></td>
                <td><div id="data"></div></td>
            </tr>
        </table>
    </div>
    <div class="wrapper">
        <label for="editor">JQUERY AJAX:</label><div id="editor"></div>
    </div>
    <div class="wrapper">
        <button type="submit">RUN</button>
        <div id="results"></div>
        <iframe id="iframe"></iframe>
    </div>

    <style>
        body {
            display: table;
            font-family: sans-serif;
        }
        h1 {
            text-align: center;
        }
        input {
            height: 20px;
            width: 100%;
            border-radius: 5px;
            border: none;
            margin: 5px 0;
        }
        .wrapper {
            display: inline-block;
            vertical-align: text-top;
            background-color: #f3f3f3;
            color: darkslategray;
            border-radius: 5px;
            margin: 5px 5px;
            padding: 15px;
        }
        .wrapper:nth-child(2) {
            width: calc(40vw - 45px);
        }
        .wrapper:nth-child(3){
            width: calc(59vw - 45px);
        }
        .wrapper:nth-child(4) {
            margin: 0;
            background: none;
            padding: 0;
            width:100%;
        }
        #editor, #headers, #data {
            border: solid 1px darkgrey;
        }
        #data, #headers, #type {
            height: 0;
        }
        #editor {
            height: 546px;
            width: 100%;
        }
        #data, #headers {
            height: 200px;
            width: 100%;
        }
        #iframe {
            width: 100%;
            height: 500px;
        }
        button[type="submit"] {
            position: relative;
            left: 50%;
            height: 50px;
            width: 300px;
            margin: 10px 0;
            border-radius: 10px;
            transform:translate(-50%);
            border: none;
            font-size: 20px;
            color: #424242;
            background-color: #74e474;
        }
        button[type="submit"]:hover {
            cursor: pointer;
        }
        table {
            width: 100%;
        }
        table tr>td:first-child {
            width: 10%;
        }
        table tr>td:last-child {
            display: flex;
            justify-content: center;
        }
        @media screen and (max-width: 1000px){
            body {
                display:block;
            }
            .wrapper {
                width: calc(100% - 45px) !important;
            }
            .wrapper:nth-child(4) {
                width: 100% !important;
            }
        }
    </style>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/ace/1.4.2/ace.js"></script>
    <script src="https://code.jquery.com/jquery-3.3.1.min.js" integrity="sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8=" crossorigin="anonymous"></script>

    <script>
        //Create the editors
        let editor = ace.edit("editor");
        let dataeditor = ace.edit("data");
        let headereditor = ace.edit("headers");
        //Set the Editor Theme
        dataeditor.setTheme("ace/theme/eclipse");
        headereditor.setTheme("ace/theme/eclipse");
        editor.setTheme("ace/theme/eclipse");
        //Set the Language
        headereditor.session.setMode("ace/mode/json");
        editor.session.setMode("ace/mode/javascript");

        //JQuery script hosting source to inject into the iframe HTML on ajax execution
        let jquery = "<script src=\"https://code.jquery.com/jquery-3.3.1.min.js\" integrity=\"sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8=\" crossorigin=\"anonymous\"><\/script>";

        let url = "";
        let method = "";
        let data = "";
        let datatype = "";
        let headers = "";

        class Ajax {
            update(canvas) {
                canvas.setValue(this.toString());
                canvas.clearSelection();
            }
            toString() {
                this.start = "$.ajax({\n" +
                    "\turl: '" + url + "',\n" +
                    "\tmethod: '" + method + "',\n";

                this.end = "\tcomplete: function(xhr, status) {\n" +
                    "\t\tconsole.log(xhr);\n" +
                    "\t\t$('body').append('STATUS: ' + xhr.status + ', ' + status + '</br>' + 'HEADERS: ' + xhr.getAllResponseHeaders() + '</br>DATA: ' + xhr.responseText);\n" +
                    "\t}\n" +
                    "});";

                this.data = "\tdata: " + data + ",\n";

                this.datatype = "\tdatatype: '" + datatype + "',\n";

                this.header = "\theaders: " + headers + ",\n";

                //Build the query
                let query = this.start;
                if (headers.length > 0) query = query + this.header;
                if (datatype.length > 0) query = query + this.datatype;
                if (data.length > 0) query = query + this.data;
                return query + this.end;
            }
        }
        var ajax = new Ajax();
        ajax.update(editor);

        $("#url").on("input", function() {
            url = $(this).val();
            ajax.update(editor);
        });
        $("#method").on("input", function() {
            method = $(this).val();
            ajax.update(editor);
        });
        $("#datatype").on("input", function() {
            datatype = $(this).val();
            //Set the datatype for the editor
            dataeditor.session.setMode("ace/mode/" + datatype);
            ajax.update(editor);
        });
        headereditor.session.on("change", function() {
            headers = headereditor.getValue();
            ajax.update(editor);
        });
        dataeditor.session.on("change", function() {
            data = dataeditor.getValue();
            ajax.update(editor);
        });
        //BELOW CODE ALLOWS DEV TO SELECT NEW CODE FROM INPUT
        // editor.session.on("change", function() {
        //     var selection = editor.selection.getCursor();
        //     var range = new ace.Range(selection.row, 0, selection.row, selection.columnCount);
        //     var string = editor.session.getTextRange(range);
        // });

        var iframe = document.getElementById('iframe');
        if (iframe.contentDocument) doc = iframe.contentDocument;
        else if (iframe.contentWindow) doc = iframe.contentWindow.document;
        else doc = iframe.document;

        $("button[type='submit']").on("click", function() {
            //Check the URL and Method first, and if missing prompt?
            if (url.length <= 0 || method.length <= 0) {
                alert("Please enter a URL and Method");
                return;
            }
            doc.open();
            doc.writeln(jquery + "<script>" + editor.getValue() + "<\/script>");
            doc.close();
        });
    </script>
</body>
</html>